// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package products

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ProductsClient is the client API for Products service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ProductsClient interface {
	// ListProductType lists ProductTypes based on the ListProductTypeRequest.
	ListProductType(ctx context.Context, in *ListProductTypeRequest, opts ...grpc.CallOption) (*ListProductTypeResponse, error)
	// GetProductType returns a specific ProductType.
	GetProductType(ctx context.Context, in *GetProductTypeRequest, opts ...grpc.CallOption) (*ProductType, error)
	// ListProducts lists Products based on the ListProductsRequest.
	ListProducts(ctx context.Context, in *ListProductsRequest, opts ...grpc.CallOption) (*ListProductsResponse, error)
	// GetProduct returns a specific Product.
	GetProduct(ctx context.Context, in *GetProductRequest, opts ...grpc.CallOption) (*Product, error)
	// BatchGetProducts returns a batch of specific Products.
	// If the method fails a list of all errors
	// will be provided in the details field of the error.
	// (see: https://cloud.google.com/apis/design/errors#error_model)
	BatchGetProducts(ctx context.Context, in *BatchGetProductsRequest, opts ...grpc.CallOption) (*BatchGetProductsResponse, error)
	// CreateProduct creates a new Product.
	CreateProduct(ctx context.Context, in *CreateProductRequest, opts ...grpc.CallOption) (*Product, error)
	// UpdateProduct updates a Product.
	UpdateProduct(ctx context.Context, in *UpdateProductRequest, opts ...grpc.CallOption) (*Product, error)
	// ListAllowedUsers lists the users allowed to buy a specific product.
	ListAllowedUsers(ctx context.Context, in *ListAllowedUsersRequest, opts ...grpc.CallOption) (*ListListAllowedUsersResponse, error)
	// UpdateAllowedUsers allows user to be added or removed from the AllowedUsers list.
	UpdateAllowedUsers(ctx context.Context, in *UpdateAllowedUsersRequest, opts ...grpc.CallOption) (*UpdateAllowedUsersResponse, error)
	// ListAllowedGroups lists the groups allowed to buy a specific product.
	ListAllowedGroups(ctx context.Context, in *ListAllowedGroupsRequest, opts ...grpc.CallOption) (*ListListAllowedGroupsResponse, error)
	// UpdateAllowedGroups allows group to be added or removed from the AllowedGroups list.
	UpdateAllowedGroups(ctx context.Context, in *UpdateAllowedGroupsRequest, opts ...grpc.CallOption) (*UpdateAllowedGroupsResponse, error)
	// ListDeniedUsers lists the users denied to buy a specific product.
	ListDeniedUsers(ctx context.Context, in *ListDeniedUsersRequest, opts ...grpc.CallOption) (*ListListDeniedUsersResponse, error)
	// UpdateDeniedUsers allows user to be added or removed from the DeniedUsers list.
	UpdateDeniedUsers(ctx context.Context, in *UpdateDeniedUsersRequest, opts ...grpc.CallOption) (*UpdateDeniedUsersResponse, error)
	// ListDeniedGroups lists the groups denied to buy a specific product.
	ListDeniedGroups(ctx context.Context, in *ListDeniedGroupsRequest, opts ...grpc.CallOption) (*ListListDeniedGroupsResponse, error)
	// UpdateDeniedGroups allows group to be added or removed from the DeniedGroups list.
	UpdateDeniedGroups(ctx context.Context, in *UpdateDeniedGroupsRequest, opts ...grpc.CallOption) (*UpdateDeniedGroupsResponse, error)
	// ListReservations lists Reservations based on the ListReservationsRequest.
	ListReservations(ctx context.Context, in *ListReservationsRequest, opts ...grpc.CallOption) (*ListReservationsResponse, error)
	// GetReservation returns a specific Reservation.
	GetReservation(ctx context.Context, in *GetReservationRequest, opts ...grpc.CallOption) (*Reservation, error)
	// BatchCreateReservations allows a batch of reservations on products to be made.
	// If the method fails no reservations will be created and a list of all errors
	// will be provided in the details field of the error.
	// (see: https://cloud.google.com/apis/design/errors#error_model)
	BatchCreateReservations(ctx context.Context, in *BatchCreateReservationsRequest, opts ...grpc.CallOption) (*BatchCreateReservationsResponse, error)
	// ListSales lists Sales based on the ListSalesRequest.
	ListSales(ctx context.Context, in *ListSalesRequest, opts ...grpc.CallOption) (*ListSalesResponse, error)
	// GetSale returns a specific Sale.
	GetSale(ctx context.Context, in *GetSaleRequest, opts ...grpc.CallOption) (*Sale, error)
	// BatchCreateSales allows a batch of sales to be created given a batch of valid reservations.
	// If the method fails no sale will be created and a list of all errors
	// will be provided in the details field of the error.
	// (see: https://cloud.google.com/apis/design/errors#error_model)
	BatchCreateSales(ctx context.Context, in *BatchCreateSalesRequest, opts ...grpc.CallOption) (*BatchCreateSalesResponse, error)
	// BatchDeleteSales allows sales to be canceled / revoked
	// If the method fails no sale will be deleted and a list of all errors
	// will be provided in the details field of the error.
	// (see: https://cloud.google.com/apis/design/errors#error_model)
	BatchDeleteSales(ctx context.Context, in *BatchDeleteSalesRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
}

type productsClient struct {
	cc grpc.ClientConnInterface
}

func NewProductsClient(cc grpc.ClientConnInterface) ProductsClient {
	return &productsClient{cc}
}

func (c *productsClient) ListProductType(ctx context.Context, in *ListProductTypeRequest, opts ...grpc.CallOption) (*ListProductTypeResponse, error) {
	out := new(ListProductTypeResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/ListProductType", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) GetProductType(ctx context.Context, in *GetProductTypeRequest, opts ...grpc.CallOption) (*ProductType, error) {
	out := new(ProductType)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/GetProductType", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) ListProducts(ctx context.Context, in *ListProductsRequest, opts ...grpc.CallOption) (*ListProductsResponse, error) {
	out := new(ListProductsResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/ListProducts", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) GetProduct(ctx context.Context, in *GetProductRequest, opts ...grpc.CallOption) (*Product, error) {
	out := new(Product)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/GetProduct", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) BatchGetProducts(ctx context.Context, in *BatchGetProductsRequest, opts ...grpc.CallOption) (*BatchGetProductsResponse, error) {
	out := new(BatchGetProductsResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/BatchGetProducts", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) CreateProduct(ctx context.Context, in *CreateProductRequest, opts ...grpc.CallOption) (*Product, error) {
	out := new(Product)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/CreateProduct", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) UpdateProduct(ctx context.Context, in *UpdateProductRequest, opts ...grpc.CallOption) (*Product, error) {
	out := new(Product)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/UpdateProduct", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) ListAllowedUsers(ctx context.Context, in *ListAllowedUsersRequest, opts ...grpc.CallOption) (*ListListAllowedUsersResponse, error) {
	out := new(ListListAllowedUsersResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/ListAllowedUsers", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) UpdateAllowedUsers(ctx context.Context, in *UpdateAllowedUsersRequest, opts ...grpc.CallOption) (*UpdateAllowedUsersResponse, error) {
	out := new(UpdateAllowedUsersResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/UpdateAllowedUsers", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) ListAllowedGroups(ctx context.Context, in *ListAllowedGroupsRequest, opts ...grpc.CallOption) (*ListListAllowedGroupsResponse, error) {
	out := new(ListListAllowedGroupsResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/ListAllowedGroups", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) UpdateAllowedGroups(ctx context.Context, in *UpdateAllowedGroupsRequest, opts ...grpc.CallOption) (*UpdateAllowedGroupsResponse, error) {
	out := new(UpdateAllowedGroupsResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/UpdateAllowedGroups", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) ListDeniedUsers(ctx context.Context, in *ListDeniedUsersRequest, opts ...grpc.CallOption) (*ListListDeniedUsersResponse, error) {
	out := new(ListListDeniedUsersResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/ListDeniedUsers", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) UpdateDeniedUsers(ctx context.Context, in *UpdateDeniedUsersRequest, opts ...grpc.CallOption) (*UpdateDeniedUsersResponse, error) {
	out := new(UpdateDeniedUsersResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/UpdateDeniedUsers", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) ListDeniedGroups(ctx context.Context, in *ListDeniedGroupsRequest, opts ...grpc.CallOption) (*ListListDeniedGroupsResponse, error) {
	out := new(ListListDeniedGroupsResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/ListDeniedGroups", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) UpdateDeniedGroups(ctx context.Context, in *UpdateDeniedGroupsRequest, opts ...grpc.CallOption) (*UpdateDeniedGroupsResponse, error) {
	out := new(UpdateDeniedGroupsResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/UpdateDeniedGroups", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) ListReservations(ctx context.Context, in *ListReservationsRequest, opts ...grpc.CallOption) (*ListReservationsResponse, error) {
	out := new(ListReservationsResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/ListReservations", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) GetReservation(ctx context.Context, in *GetReservationRequest, opts ...grpc.CallOption) (*Reservation, error) {
	out := new(Reservation)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/GetReservation", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) BatchCreateReservations(ctx context.Context, in *BatchCreateReservationsRequest, opts ...grpc.CallOption) (*BatchCreateReservationsResponse, error) {
	out := new(BatchCreateReservationsResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/BatchCreateReservations", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) ListSales(ctx context.Context, in *ListSalesRequest, opts ...grpc.CallOption) (*ListSalesResponse, error) {
	out := new(ListSalesResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/ListSales", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) GetSale(ctx context.Context, in *GetSaleRequest, opts ...grpc.CallOption) (*Sale, error) {
	out := new(Sale)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/GetSale", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) BatchCreateSales(ctx context.Context, in *BatchCreateSalesRequest, opts ...grpc.CallOption) (*BatchCreateSalesResponse, error) {
	out := new(BatchCreateSalesResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/BatchCreateSales", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *productsClient) BatchDeleteSales(ctx context.Context, in *BatchDeleteSalesRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.sip.products.Products/BatchDeleteSales", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ProductsServer is the server API for Products service.
// All implementations must embed UnimplementedProductsServer
// for forward compatibility
type ProductsServer interface {
	// ListProductType lists ProductTypes based on the ListProductTypeRequest.
	ListProductType(context.Context, *ListProductTypeRequest) (*ListProductTypeResponse, error)
	// GetProductType returns a specific ProductType.
	GetProductType(context.Context, *GetProductTypeRequest) (*ProductType, error)
	// ListProducts lists Products based on the ListProductsRequest.
	ListProducts(context.Context, *ListProductsRequest) (*ListProductsResponse, error)
	// GetProduct returns a specific Product.
	GetProduct(context.Context, *GetProductRequest) (*Product, error)
	// BatchGetProducts returns a batch of specific Products.
	// If the method fails a list of all errors
	// will be provided in the details field of the error.
	// (see: https://cloud.google.com/apis/design/errors#error_model)
	BatchGetProducts(context.Context, *BatchGetProductsRequest) (*BatchGetProductsResponse, error)
	// CreateProduct creates a new Product.
	CreateProduct(context.Context, *CreateProductRequest) (*Product, error)
	// UpdateProduct updates a Product.
	UpdateProduct(context.Context, *UpdateProductRequest) (*Product, error)
	// ListAllowedUsers lists the users allowed to buy a specific product.
	ListAllowedUsers(context.Context, *ListAllowedUsersRequest) (*ListListAllowedUsersResponse, error)
	// UpdateAllowedUsers allows user to be added or removed from the AllowedUsers list.
	UpdateAllowedUsers(context.Context, *UpdateAllowedUsersRequest) (*UpdateAllowedUsersResponse, error)
	// ListAllowedGroups lists the groups allowed to buy a specific product.
	ListAllowedGroups(context.Context, *ListAllowedGroupsRequest) (*ListListAllowedGroupsResponse, error)
	// UpdateAllowedGroups allows group to be added or removed from the AllowedGroups list.
	UpdateAllowedGroups(context.Context, *UpdateAllowedGroupsRequest) (*UpdateAllowedGroupsResponse, error)
	// ListDeniedUsers lists the users denied to buy a specific product.
	ListDeniedUsers(context.Context, *ListDeniedUsersRequest) (*ListListDeniedUsersResponse, error)
	// UpdateDeniedUsers allows user to be added or removed from the DeniedUsers list.
	UpdateDeniedUsers(context.Context, *UpdateDeniedUsersRequest) (*UpdateDeniedUsersResponse, error)
	// ListDeniedGroups lists the groups denied to buy a specific product.
	ListDeniedGroups(context.Context, *ListDeniedGroupsRequest) (*ListListDeniedGroupsResponse, error)
	// UpdateDeniedGroups allows group to be added or removed from the DeniedGroups list.
	UpdateDeniedGroups(context.Context, *UpdateDeniedGroupsRequest) (*UpdateDeniedGroupsResponse, error)
	// ListReservations lists Reservations based on the ListReservationsRequest.
	ListReservations(context.Context, *ListReservationsRequest) (*ListReservationsResponse, error)
	// GetReservation returns a specific Reservation.
	GetReservation(context.Context, *GetReservationRequest) (*Reservation, error)
	// BatchCreateReservations allows a batch of reservations on products to be made.
	// If the method fails no reservations will be created and a list of all errors
	// will be provided in the details field of the error.
	// (see: https://cloud.google.com/apis/design/errors#error_model)
	BatchCreateReservations(context.Context, *BatchCreateReservationsRequest) (*BatchCreateReservationsResponse, error)
	// ListSales lists Sales based on the ListSalesRequest.
	ListSales(context.Context, *ListSalesRequest) (*ListSalesResponse, error)
	// GetSale returns a specific Sale.
	GetSale(context.Context, *GetSaleRequest) (*Sale, error)
	// BatchCreateSales allows a batch of sales to be created given a batch of valid reservations.
	// If the method fails no sale will be created and a list of all errors
	// will be provided in the details field of the error.
	// (see: https://cloud.google.com/apis/design/errors#error_model)
	BatchCreateSales(context.Context, *BatchCreateSalesRequest) (*BatchCreateSalesResponse, error)
	// BatchDeleteSales allows sales to be canceled / revoked
	// If the method fails no sale will be deleted and a list of all errors
	// will be provided in the details field of the error.
	// (see: https://cloud.google.com/apis/design/errors#error_model)
	BatchDeleteSales(context.Context, *BatchDeleteSalesRequest) (*emptypb.Empty, error)
	mustEmbedUnimplementedProductsServer()
}

// UnimplementedProductsServer must be embedded to have forward compatible implementations.
type UnimplementedProductsServer struct {
}

func (UnimplementedProductsServer) ListProductType(context.Context, *ListProductTypeRequest) (*ListProductTypeResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListProductType not implemented")
}
func (UnimplementedProductsServer) GetProductType(context.Context, *GetProductTypeRequest) (*ProductType, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetProductType not implemented")
}
func (UnimplementedProductsServer) ListProducts(context.Context, *ListProductsRequest) (*ListProductsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListProducts not implemented")
}
func (UnimplementedProductsServer) GetProduct(context.Context, *GetProductRequest) (*Product, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetProduct not implemented")
}
func (UnimplementedProductsServer) BatchGetProducts(context.Context, *BatchGetProductsRequest) (*BatchGetProductsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method BatchGetProducts not implemented")
}
func (UnimplementedProductsServer) CreateProduct(context.Context, *CreateProductRequest) (*Product, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateProduct not implemented")
}
func (UnimplementedProductsServer) UpdateProduct(context.Context, *UpdateProductRequest) (*Product, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateProduct not implemented")
}
func (UnimplementedProductsServer) ListAllowedUsers(context.Context, *ListAllowedUsersRequest) (*ListListAllowedUsersResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListAllowedUsers not implemented")
}
func (UnimplementedProductsServer) UpdateAllowedUsers(context.Context, *UpdateAllowedUsersRequest) (*UpdateAllowedUsersResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateAllowedUsers not implemented")
}
func (UnimplementedProductsServer) ListAllowedGroups(context.Context, *ListAllowedGroupsRequest) (*ListListAllowedGroupsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListAllowedGroups not implemented")
}
func (UnimplementedProductsServer) UpdateAllowedGroups(context.Context, *UpdateAllowedGroupsRequest) (*UpdateAllowedGroupsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateAllowedGroups not implemented")
}
func (UnimplementedProductsServer) ListDeniedUsers(context.Context, *ListDeniedUsersRequest) (*ListListDeniedUsersResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListDeniedUsers not implemented")
}
func (UnimplementedProductsServer) UpdateDeniedUsers(context.Context, *UpdateDeniedUsersRequest) (*UpdateDeniedUsersResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateDeniedUsers not implemented")
}
func (UnimplementedProductsServer) ListDeniedGroups(context.Context, *ListDeniedGroupsRequest) (*ListListDeniedGroupsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListDeniedGroups not implemented")
}
func (UnimplementedProductsServer) UpdateDeniedGroups(context.Context, *UpdateDeniedGroupsRequest) (*UpdateDeniedGroupsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateDeniedGroups not implemented")
}
func (UnimplementedProductsServer) ListReservations(context.Context, *ListReservationsRequest) (*ListReservationsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListReservations not implemented")
}
func (UnimplementedProductsServer) GetReservation(context.Context, *GetReservationRequest) (*Reservation, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetReservation not implemented")
}
func (UnimplementedProductsServer) BatchCreateReservations(context.Context, *BatchCreateReservationsRequest) (*BatchCreateReservationsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method BatchCreateReservations not implemented")
}
func (UnimplementedProductsServer) ListSales(context.Context, *ListSalesRequest) (*ListSalesResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListSales not implemented")
}
func (UnimplementedProductsServer) GetSale(context.Context, *GetSaleRequest) (*Sale, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetSale not implemented")
}
func (UnimplementedProductsServer) BatchCreateSales(context.Context, *BatchCreateSalesRequest) (*BatchCreateSalesResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method BatchCreateSales not implemented")
}
func (UnimplementedProductsServer) BatchDeleteSales(context.Context, *BatchDeleteSalesRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method BatchDeleteSales not implemented")
}
func (UnimplementedProductsServer) mustEmbedUnimplementedProductsServer() {}

// UnsafeProductsServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ProductsServer will
// result in compilation errors.
type UnsafeProductsServer interface {
	mustEmbedUnimplementedProductsServer()
}

func RegisterProductsServer(s grpc.ServiceRegistrar, srv ProductsServer) {
	s.RegisterService(&Products_ServiceDesc, srv)
}

func _Products_ListProductType_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListProductTypeRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).ListProductType(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/ListProductType",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).ListProductType(ctx, req.(*ListProductTypeRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_GetProductType_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetProductTypeRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).GetProductType(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/GetProductType",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).GetProductType(ctx, req.(*GetProductTypeRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_ListProducts_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListProductsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).ListProducts(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/ListProducts",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).ListProducts(ctx, req.(*ListProductsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_GetProduct_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetProductRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).GetProduct(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/GetProduct",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).GetProduct(ctx, req.(*GetProductRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_BatchGetProducts_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BatchGetProductsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).BatchGetProducts(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/BatchGetProducts",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).BatchGetProducts(ctx, req.(*BatchGetProductsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_CreateProduct_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateProductRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).CreateProduct(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/CreateProduct",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).CreateProduct(ctx, req.(*CreateProductRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_UpdateProduct_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateProductRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).UpdateProduct(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/UpdateProduct",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).UpdateProduct(ctx, req.(*UpdateProductRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_ListAllowedUsers_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListAllowedUsersRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).ListAllowedUsers(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/ListAllowedUsers",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).ListAllowedUsers(ctx, req.(*ListAllowedUsersRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_UpdateAllowedUsers_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateAllowedUsersRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).UpdateAllowedUsers(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/UpdateAllowedUsers",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).UpdateAllowedUsers(ctx, req.(*UpdateAllowedUsersRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_ListAllowedGroups_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListAllowedGroupsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).ListAllowedGroups(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/ListAllowedGroups",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).ListAllowedGroups(ctx, req.(*ListAllowedGroupsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_UpdateAllowedGroups_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateAllowedGroupsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).UpdateAllowedGroups(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/UpdateAllowedGroups",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).UpdateAllowedGroups(ctx, req.(*UpdateAllowedGroupsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_ListDeniedUsers_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListDeniedUsersRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).ListDeniedUsers(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/ListDeniedUsers",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).ListDeniedUsers(ctx, req.(*ListDeniedUsersRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_UpdateDeniedUsers_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateDeniedUsersRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).UpdateDeniedUsers(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/UpdateDeniedUsers",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).UpdateDeniedUsers(ctx, req.(*UpdateDeniedUsersRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_ListDeniedGroups_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListDeniedGroupsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).ListDeniedGroups(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/ListDeniedGroups",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).ListDeniedGroups(ctx, req.(*ListDeniedGroupsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_UpdateDeniedGroups_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateDeniedGroupsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).UpdateDeniedGroups(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/UpdateDeniedGroups",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).UpdateDeniedGroups(ctx, req.(*UpdateDeniedGroupsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_ListReservations_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListReservationsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).ListReservations(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/ListReservations",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).ListReservations(ctx, req.(*ListReservationsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_GetReservation_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetReservationRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).GetReservation(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/GetReservation",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).GetReservation(ctx, req.(*GetReservationRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_BatchCreateReservations_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BatchCreateReservationsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).BatchCreateReservations(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/BatchCreateReservations",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).BatchCreateReservations(ctx, req.(*BatchCreateReservationsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_ListSales_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListSalesRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).ListSales(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/ListSales",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).ListSales(ctx, req.(*ListSalesRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_GetSale_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetSaleRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).GetSale(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/GetSale",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).GetSale(ctx, req.(*GetSaleRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_BatchCreateSales_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BatchCreateSalesRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).BatchCreateSales(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/BatchCreateSales",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).BatchCreateSales(ctx, req.(*BatchCreateSalesRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Products_BatchDeleteSales_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BatchDeleteSalesRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProductsServer).BatchDeleteSales(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.products.Products/BatchDeleteSales",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProductsServer).BatchDeleteSales(ctx, req.(*BatchDeleteSalesRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Products_ServiceDesc is the grpc.ServiceDesc for Products service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Products_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "vseth.sip.products.Products",
	HandlerType: (*ProductsServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "ListProductType",
			Handler:    _Products_ListProductType_Handler,
		},
		{
			MethodName: "GetProductType",
			Handler:    _Products_GetProductType_Handler,
		},
		{
			MethodName: "ListProducts",
			Handler:    _Products_ListProducts_Handler,
		},
		{
			MethodName: "GetProduct",
			Handler:    _Products_GetProduct_Handler,
		},
		{
			MethodName: "BatchGetProducts",
			Handler:    _Products_BatchGetProducts_Handler,
		},
		{
			MethodName: "CreateProduct",
			Handler:    _Products_CreateProduct_Handler,
		},
		{
			MethodName: "UpdateProduct",
			Handler:    _Products_UpdateProduct_Handler,
		},
		{
			MethodName: "ListAllowedUsers",
			Handler:    _Products_ListAllowedUsers_Handler,
		},
		{
			MethodName: "UpdateAllowedUsers",
			Handler:    _Products_UpdateAllowedUsers_Handler,
		},
		{
			MethodName: "ListAllowedGroups",
			Handler:    _Products_ListAllowedGroups_Handler,
		},
		{
			MethodName: "UpdateAllowedGroups",
			Handler:    _Products_UpdateAllowedGroups_Handler,
		},
		{
			MethodName: "ListDeniedUsers",
			Handler:    _Products_ListDeniedUsers_Handler,
		},
		{
			MethodName: "UpdateDeniedUsers",
			Handler:    _Products_UpdateDeniedUsers_Handler,
		},
		{
			MethodName: "ListDeniedGroups",
			Handler:    _Products_ListDeniedGroups_Handler,
		},
		{
			MethodName: "UpdateDeniedGroups",
			Handler:    _Products_UpdateDeniedGroups_Handler,
		},
		{
			MethodName: "ListReservations",
			Handler:    _Products_ListReservations_Handler,
		},
		{
			MethodName: "GetReservation",
			Handler:    _Products_GetReservation_Handler,
		},
		{
			MethodName: "BatchCreateReservations",
			Handler:    _Products_BatchCreateReservations_Handler,
		},
		{
			MethodName: "ListSales",
			Handler:    _Products_ListSales_Handler,
		},
		{
			MethodName: "GetSale",
			Handler:    _Products_GetSale_Handler,
		},
		{
			MethodName: "BatchCreateSales",
			Handler:    _Products_BatchCreateSales_Handler,
		},
		{
			MethodName: "BatchDeleteSales",
			Handler:    _Products_BatchDeleteSales_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "vseth/sip/products/products.proto",
}
